#ifndef __FAKECALL_H_INCLUDED__
#define __FAKECALL_H_INCLUDED__

#include <systraps.h>
#include "debug.h"

typedef WORD UInt;

class FakeCall {
public:
  FakeCall();
  ~FakeCall();
  void PushWord(WORD x);
  void PushUInt(UInt x) { PushWord( x ); }
  void PushLong(DWORD x);
  void PushULong(ULong x) { PushLong( x ); }
  void *PushPtr(int size);
  void Call(WORD api, BOOL debug = FALSE);
  DWORD GetResultD0();
  DWORD GetResultA0();
private:
	bool m_CpuWasRunning;
  CPU_regs origregs, regs;
  enum {addrstart = 0x2000};
  DWORD nextaddr;
  void *SaveMemory;
  void PutSwap(DWORD addr, WORD word);
  void SwapRange(DWORD startaddr, DWORD endaddr);
};

inline WORD swap(WORD x) { return (x << 8) | (x >> 8); }
inline DWORD swap32(DWORD x) 
{
	unsigned char a[4];
	unsigned char t;
	memcpy( a, &x, 4 );
	t = a[3];
	a[3] = a[0];
	a[0] = t;
	t = a[2];
	a[2] = a[1];
	a[1] = t;
	memcpy( &x, a, 4 );

	return (x); 
}

const DWORD memErrNotEnoughSpace	= 0x102;
const DWORD dmErrROMBased			= 0x20E;
const DWORD dmErrDatabaseOpen		= 0x205;

const WORD dmModeReadWrite = 3;

#endif //  __FAKECALL_H_INCLUDED__